// prefix_and_postfix.cpp
//
// Prefixovy a postfixovy operator ++ pro vyctovy typ
#ifdef _WIN32
	#include <tchar.h>
	#include <conio.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <iostream>
using namespace std;

enum dny { po, ut, st, ct, pa, so, ne };

dny operator++(dny& d) // Prefixovy operator
{
	int i = d;
	i++;		// Zde se pouzije operator ++ pro cela cisla
	if (i > ne) i = po;
	d = dny(i);	// Zmenime operand
	return d;	// a zmeneny operand vratime
}

dny operator++(dny& d, int) // Postfixovy operator
{
	dny D = d;	// Zapamatujeme si puvodni hodnotu
	int i = d;	// zmenime operand
	i++;
	if (i > ne) i = po;
	d = dny(i);
	return D;	// a puvodni hodnotu vratime
}

void my_getch();

int main()
{
	dny d = po;
	cout << endl << "dny d = po; d = " << d << endl;
	dny e = ++d;
	cout << "dny e = ++d; e = " << e << endl << endl;

	d = po;
	cout << "d = po; d = " << d << endl;
	e = d++;
	cout << "e = d++; e = " << e << endl;
	cout << "d = " << d << endl;
	my_getch();
	return 0;
}
//---------------------------------------------------------------------------
void my_getch()
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------
